package com.logicbig.example;

import org.primefaces.context.RequestContext;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.ViewScoped;
import javax.faces.event.ActionEvent;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

@ManagedBean
@ViewScoped
public class MainBean {
    public String[] selectedDepartments =
            Arrays.copyOf(Employee.DepartmentList, Employee.DepartmentList.length);

    public void showEmployees(ActionEvent ae) {
        String selectedDeptsAsParam = Arrays.stream(getSelectedDepartments())
                                            .collect(Collectors.joining("|"));
        Map<String, List<String>> params = new HashMap<>();
        params.put("selectedDepartments", Arrays.asList(selectedDeptsAsParam));
        RequestContext.getCurrentInstance().openDialog("employee",
                getDialogOptions(), params);
    }

    public Map<String, Object> getDialogOptions() {
        Map<String, Object> options = new HashMap<>();
        options.put("resizable", false);
        options.put("draggable", true);
        options.put("modal", true);
        options.put("height", 400);
        options.put("contentHeight", "100%");
        return options;
    }

    public String[] getDepartmentList() {
        return Employee.DepartmentList;
    }

    public String[] getSelectedDepartments() {
        return selectedDepartments;
    }

    public void setSelectedDepartments(String[] selectedDepartments) {
        this.selectedDepartments = selectedDepartments;
    }
}